
/* RJVirtualCamera3DManager.h */

#ifndef ROKOJORI__VIRTUAL_CAMERA_3_D_MANAGER_H
#define ROKOJORI__VIRTUAL_CAMERA_3_D_MANAGER_H

#include "./RJGodotHeaders.h"
#include "./RJVirtualCamera3D.h"
#include "./RJNetworkNode.h"




class RJVirtualCamera3DManager : public RJNetworkNode 
{
  GDCLASS( RJVirtualCamera3DManager, RJNetworkNode );

protected:
  static void _bind_methods();
  

  
  //  cameraPrioritySmoothingCoefficient : float
  float cameraPrioritySmoothingCoefficient;
  
  //  cameraPrioritySmoothingStepFPS : float
  float cameraPrioritySmoothingStepFPS;

public:

  
  //  getCamera( int cameraIndex ) : Ref<RJVirtualCamera3D>
  GDVIRTUAL1R( Ref<RJVirtualCamera3D>, getCamera, int );
  
  //  getCameraIndex( Ref<RJVirtualCamera3D> timeLine ) : int
  GDVIRTUAL1R( int, getCameraIndex, Ref<RJVirtualCamera3D> );
  
  //  getCameraSize() : int
  GDVIRTUAL0R( int, getCameraSize );
  
  //  getCameraPriority( int cameraIndex ) : float
  GDVIRTUAL1R( float, getCameraPriority, int );
  
  //  setCameraPriority( int cameraIndex, float priority ) : void
  GDVIRTUAL2( setCameraPriority, int, float );
  
  //  cameraPrioritySmoothingCoefficient : float
  float get_cameraPrioritySmoothingCoefficient(); void set_cameraPrioritySmoothingCoefficient( float p_cameraPrioritySmoothingCoefficient );
  
  //  cameraPrioritySmoothingStepFPS : float
  float get_cameraPrioritySmoothingStepFPS(); void set_cameraPrioritySmoothingStepFPS( float p_cameraPrioritySmoothingStepFPS );

  //  Constructor
  RJVirtualCamera3DManager();

  //  Destructor
  ~RJVirtualCamera3DManager();
};


#endif // ROKOJORI__VIRTUAL_CAMERA_3_D_MANAGER_H
