/* register_types.cpp */

#include "register_types.h"

#include "core/object/class_db.h"

#include "./RJAction.h"
#include "./RJCaster.h"
#include "./RJIntProperty.h"
#include "./RJNetworkNode.h"
#include "./RJPointable.h"
#include "./RJPointer.h"
#include "./RJSelector.h"
#include "./RJSensor.h"
#include "./RJSequenceAction.h"
#include "./RJTimeLine.h"
#include "./RJTimeLineManager.h"
#include "./RJUpdatable.h"
#include "./RJVirtualCamera3D.h"
#include "./RJVirtualCamera3DManager.h"

void initialize_rokojori_action_library_module( ModuleInitializationLevel p_level ) 
{
  if ( p_level != MODULE_INITIALIZATION_LEVEL_SCENE ) 
  {
    return;
  }

  ClassDB::register_class<RJAction>();
  ClassDB::register_class<RJCaster>();
  ClassDB::register_class<RJIntProperty>();
  ClassDB::register_class<RJNetworkNode>();
  ClassDB::register_class<RJPointable>();
  ClassDB::register_class<RJPointer>();
  ClassDB::register_class<RJSelector>();
  ClassDB::register_class<RJSensor>();
  ClassDB::register_class<RJSequenceAction>();
  ClassDB::register_class<RJTimeLine>();
  ClassDB::register_class<RJTimeLineManager>();
  ClassDB::register_class<RJUpdatable>();
  ClassDB::register_class<RJVirtualCamera3D>();
  ClassDB::register_class<RJVirtualCamera3DManager>();
}

void uninitialize_rokojori_action_library_module( ModuleInitializationLevel p_level ) 
{
  if ( p_level != MODULE_INITIALIZATION_LEVEL_SCENE ) 
  {
    return;
  }
  
}


